/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/* Copyright (c) 2007 Kimmo Kinnunen. All rights reserved.
 * bsd licence
 */
#ifndef webi_auth_h
#define webi_auth_h

/**
 * Provides default implementation for authentication
 * "database"
 */

#include <glib.h>


G_BEGIN_DECLS

#include <webi-types.h>

struct WebiAuthListEntry_ {
  gchar* username;
  gchar* password;
};

WebiAuthList* webi_auth_list_new();
void webi_auth_list_destroy();

/** insert to list
 * ownership transferred
 */
void webi_auth_list_insert(WebiAuthList* self, const gchar* url, const gchar* realm, WebiAuthListEntry* entry);


WebiAuthListEntry* webi_auth_list_lookup(WebiAuthList* self, const gchar* url, const gchar* realm);

WebiAuthListEntry* webi_auth_list_entry_new();

G_END_DECLS
#endif
