/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/* Copyright (c) 2007 Kimmo Kinnunen. All rights reserved.
 * bsd license
 */
#ifndef webi_external_content_delegate_h
#define webi_external_content_delegate_h

#include <glib-object.h>
#include <webi-types.h>
#include <webi-resource.h>

G_BEGIN_DECLS

#define WEBI_TYPE_EXTERNAL_CONTENT_DELEGATE                (webi_external_content_delegate_get_type ())
#define WEBI_EXTERNAL_CONTENT_DELEGATE(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), WEBI_TYPE_EXTERNAL_CONTENT_DELEGATE, WebiExternalContentDelegate))
#define WEBI_IS_EXTERNAL_CONTENT_DELEGATE(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WEBI_TYPE_EXTERNAL_CONTENT_DELEGATE))
#define WEBI_EXTERNAL_CONTENT_DELEGATE_GET_INTERFACE(inst) (G_TYPE_INSTANCE_GET_INTERFACE ((inst), WEBI_TYPE_EXTERNAL_CONTENT_DELEGATE, WebiExternalContentDelegateInterface))

typedef struct WebiExternalContentDelegate_ WebiExternalContentDelegate; /* dummy object */
typedef struct WebiExternalContentDelegateInterface_ WebiExternalContentDelegateInterface;

struct WebiExternalContentDelegateInterface_ {
  GTypeInterface parent;

  void (*start) (WebiExternalContentDelegate *self, WebiResource *resource);
  void (*data) (WebiExternalContentDelegate *self, WebiResource *resource, const gchar* data, int len);
  void (*end) (WebiExternalContentDelegate *self, WebiResource *resource, gboolean got_error);
};

GType webi_external_content_delegate_get_type (void);

void webi_external_content_delegate_start (WebiExternalContentDelegate *self, WebiResource *resource);
void webi_external_content_delegate_data (WebiExternalContentDelegate *self, WebiResource *resource, const gchar* data, int len);
void webi_external_content_delegate_end (WebiExternalContentDelegate *self, WebiResource *resource, gboolean got_error);

G_END_DECLS

#endif
