/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/* Copyright (c) 2007 Kimmo Kinnunen. All rights reserved.
 * bsd license
 */
#ifndef webi_resource_h
#define webi_resource_h

#include <glib-object.h>

G_BEGIN_DECLS

#include <webi-types.h>

#define WEBI_TYPE_RESOURCE                (webi_resource_get_type ())
#define WEBI_RESOURCE(obj)                (G_TYPE_CHECK_INSTANCE_CAST ((obj), WEBI_TYPE_RESOURCE, WebiResource))
#define WEBI_RESOURCE_CLASS(klass)        (G_TYPE_CHECK_CLASS_CAST((klass), WEBI_TYPE_RESOURCE, WebiResourceClass))
#define WEBI_IS_RESOURCE(obj)             (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WEBI_TYPE_RESOURCE))


/** represents external resource
 * in practice this is file loaded from an url
 */
struct WebiResource_ {
	GObject parent;

	/* url of the resource*/
	gchar* url;

	/** mime type of the resource */
	gchar* mime_type;

	/** length of the resource in bytes. -1 if length not known*/
	long content_length;

	/** user modifiable data ptr*/
	void* user_data;
};

struct WebiResourceClass_ {
	GObjectClass parent_class;

};

GType webi_resource_get_type (void);

/* "abstract" type - user cannot create this*/

void webi_resource_cancel_load (WebiResource* self);

G_END_DECLS

#endif


