/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

#ifndef loader_Loader_h
#define loader_Loader_h

#include "own_gcharptr.h"

namespace Loader {

class Request;

class RequestListener
{
public:
	virtual ~RequestListener() {}

	virtual void started(const Request*) =0;
	virtual void finished(const Request*) =0;

	virtual void data(const Request*, const char* data, int len) =0;

	virtual void error(const Request* ) =0;
};

class Request
{
public:
    virtual ~Request() {};

	virtual void execute() = 0;
	virtual void stop() = 0;

	void setReferrer(const gchar* str) { m_referrer = str;}
	const gchar* referrer() const { return m_referrer; }

	void setUserAgent(const gchar* str) { m_agent = str; }
	const gchar* userAgent() const { return m_agent; }

	void setForceReload(bool force) { m_reload = force;}
	bool forceReload() const {return m_reload;}

    const gchar* url() const { return m_url; }
protected:
	own_gcharptr m_url;
	own_gcharptr m_referrer;
	own_gcharptr m_agent;
	bool m_reload;
};

};

#endif
