/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* Copyright (C) 2007 Kimmo Kinnunen<kimmok@iki.fi>
 * bsd license
 */

#ifndef unittest_TestSet_h
#define unittest_TestSet_h

#include <glib.h>
namespace nrcittest {

class TestSet
{
public:
	TestSet() : m_nfailures(0), m_ntests(0) {};
	~TestSet() {};

	void test(bool res, const gchar* expectedstr, const gchar* resultstr) {
		if (!res) {
			g_printerr("Test #%d failed.\n Exp:'%s'.\n Got:'%s'.\n", m_ntests, expectedstr, resultstr);
			++m_nfailures;
		}
		++m_ntests;
	}

	void test(bool res, int e, int r) {
		if (!res) {
			g_printerr("Test #%d failed.\n Exp:'%d'.\n Got:'%d'.\n", m_ntests, e, r);
            ++m_nfailures;
		}
        
		++m_ntests;
    }

	int failures() const { return m_nfailures; }

private:
	int m_nfailures;
	int m_ntests;
};

}
#endif
