/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/* Copyright (c) 2007 Kimmo Kinnunen. All rights reserved.
 * bsd license
 */

#ifndef webkit_frame_load_delegate_h
#define webkit_frame_load_delegate_h


#include <glib.h>
#include <glib-object.h>

/* this public api is not yet implemented in gtk-webcore. patches welcome :)
 */
G_BEGIN_DECLS
#include <webkit-gtk/webkit-types.h>


#define WEBKIT_TYPE_FRAME_LOAD_DELEGATE (webkit_frame_load_delegate_get_type())
#define WEBKIT_FRAME_LOAD_DELEGATE(obj)   G_TYPE_CHECK_INSTANCE_CAST((obj), webkit_frame_load_delegate_get_type(), WebkitFrameExternalContentDelegate)
#define WEBKIT_FRAME_LOAD_DELEGATE_CONST(obj) G_TYPE_CHECK_INSTANCE_CAST((obj), webkit_frame_load_delegate_get_type(), WebkitFrameExternalContentDelegate const)
#define WEBKIT_IS_FRAME_LOAD_DELEGATE(obj)   G_TYPE_CHECK_INSTANCE_TYPE((obj), webkit_frame_load_delegate_get_type ())

#define WEBKIT_FRAME_LOAD_DELEGATE_GET_IFACE(obj) G_TYPE_INSTANCE_GET_INTERFACE((obj), webkit_frame_load_delegate_get_type(), WebkitFrameLoadDelegateInterface)

struct WebkitFrameLoadDelegateInterface_ {
	GTypeInterface parent;
	void (*did_start_provisional_load)(WebkitFrame* frame);
	void (*did_receive_server_redirect_for_provisional_load)(WebkitFrame* frame);
	void (*did_fail_provisional_load)(WebkitFrame* frame);
	void (*did_commit_load)(WebkitFrame* frame);

	void (*did_receive_title)(WebkitFrame* frame, const gchar* title);
	void (*did_finish_load)(WebkitFrame* frame);
	void (*did_fail_load)(WebkitFrame* frame);

};

GType webkit_frame_load_delegate_get_type();


void webkit_frame_load_delegate_did_start_provisional_load(WebkitFrameLoadDelegate* self, WebkitFrame* frame);
void webkit_frame_load_delegate_did_receive_server_redirect_for_provisional_load(WebkitFrameLoadDelegate* self, WebkitFrame* frame);
void webkit_frame_load_delegate_did_fail_provisional_load(WebkitFrameLoadDelegate* self, WebkitFrame* frame);
void webkit_frame_load_delegate_did_commit_load(WebkitFrameLoadDelegate* self, WebkitFrame* frame);

void webkit_frame_load_delegate_did_receive_title(WebkitFrameLoadDelegate* self, WebkitFrame* frame, const gchar* title);
void webkit_frame_load_delegate_did_finish_load(WebkitFrameLoadDelegate* self, WebkitFrame* frame);
void webkit_frame_load_delegate_did_fail_load(WebkitFrameLoadDelegate* self, WebkitFrame* frame);



G_END_DECLS

#endif
